.model tiny
.code
org 100h

_main:
jmp start

; text data:
msg1 db 0Dh,0Ah, "Iveskite fibonacio skaiciaus numeri, arba <=0, jei norite iseiti: $"
msg2 db 0Dh,0Ah, "Tai yra skaicius: $"

; buffer for int 21h/0ah
; fist byte is buffer size,
	; second byte is number of chars actually read (set by int 21h/0ah).
	buffer db 7,?, 5 dup (0), 0, 0

	; for result:
	binary dw ?  ;nuskaitytas skaicius bus cia

	start:

	; iveskite fibonacio skaiciaus nr 
	mov dx, offset msg1
	mov ah, 9
	int 21h

	; input string:
	mov dx, offset buffer
	mov ah, 0ah
	int 21h

	; make sure the string is zero terminated:
	mov bx, 0
	mov bl, buffer[1]
	mov buffer[bx+2], 0


	lea    si, buffer + 2  ; buffer starts from third byte.
	call    tobin ;konvertuojam nuskaityta skaiciu i dvejetaini

	; the number is in cx register.
	; for '-1234' it's 0fb2eh

	mov binary, cx ;valio turime binarine israiska kintamajame binary
	jcxz stop; ;jei vartotojas ivede 0
	mov bx, binary
	test bx, 1000000000000000b  ; test first bit.
	jnz stop 

	; zinute : Tai yra fibonacio skaicius: 
	mov dx, offset msg2
	mov ah, 9
	int 21h

	;let's count da' number 
	mov cx, 1 ;pirmas skaicius
	mov ax, 1 ;antras skaicius
	cmp bx, 1 ;ar ivestas 1? 
	je endloop

	dec bx;
	count:
	mov si, 0
	add si, cx
	add si, ax
	mov cx, ax
	mov ax, si	
	dec bx
	cmp bx, 0
	jne count

	endloop:
	;isspausdinam atsakyma
	call spausdinkSk

	jmp start  ; loop

	stop:

	ret ; return control to the operating system.


	;###########################################
	;################TO BIN#####################
	;###########################################
	;
	; 
	;
	; this procedure converts string number to
	; binary number. number can have a sign ('-').
	; the result is stored in cx register.
	; parameters:
	; si - address of string number (zero terminated).

	tobin   proc    near
	push    dx
	push    ax
	push    si


	jmp process

	;==== local variables ====      
	make_minus      db      ?       ; used as a flag.
	ten             dw      10      ; used as multiplier.
	;=========================

	process:       

	; reset the accumulator:
	mov     cx, 0

	; reset flag:
	mov     cs:make_minus, 0

	next_digit:

	; read char to al and
	; point to next byte:
	mov     al, [si]
	inc    si     

	; check for end of string:
	cmp     al, 0  ; end of string?
	jne     not_end
	jmp     stop_input       
	not_end:

	; check for minus:
	cmp     al, '-'
	jne     ok_digit
	mov     cs:make_minus, 1 ; set flag!
	jmp     next_digit

	ok_digit:

	; multiply cx by 10 (first time the result is zero)
	push    ax
	mov     ax, cx
	mul     cs:ten                  ; dx:ax = ax*10
	mov     cx, ax
	pop     ax

	; it is assumed that dx is zero - overflow not checked!

	; convert from ascii code:
	sub     al, 30h

	; add al to cx:
	mov     ah, 0
	mov     dx, cx      ; backup, in case the result will be too big.
	add     cx, ax

	; add - overflow not checked!

	jmp     next_digit

	stop_input:

	; check flag, if string number had '-'
	; make sure the result is negative:
	cmp     cs:make_minus, 0
	je      not_minus
	neg     cx

	not_minus:

	pop     si
	pop     ax
	pop     dx
	ret
	tobin        endp

	;###########################################
	;###############spausdinkSk#################
	;###########################################

	spausdinkSk proc near
	;konvertuoja registro ax reiksme i simbolini desimtaini sk.
	;ir atspausdina
	xor  bx, bx
	xor  si, si
	invert:                ;is pradziu reikia invertuoti skaiciaus skaitmenis
	cmp  ax, 0
	je   printOut
	mov  cx, 10
	xor  dx, dx
	div  cx
	push ax
	push dx
	xor  ax, ax
	mov  ax, 10
	mul  bx
	mov  bx, ax
	inc  si
	pop  dx
	pop  ax

	add  bx, dx
	jmp  invert

	printOut:              ;o tada galima isspausdint skaitmeni ax'e, dalinant ji is 10 ir spausdinant liekana
	mov  ax, bx
	xor  dx, dx

	skloop:
	xor  dx, dx
	cmp  si, 0
	jne  continue
	ret
	continue:
        dec  si
	mov  cx, 10
	div  cx
	push ax
	add  dx, 30h                        ;= 48d
	mov  ah, 2
	int  21h
	pop ax

	jmp skloop

	spausdinkSk endp

	end _main